"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TcDate = void 0;
var tslib_1 = require("tslib");
var get_date_locale_1 = require("../../helpers/get-date-locale");
var addMonths_1 = tslib_1.__importDefault(require("date-fns/addMonths"));
var addWeeks_1 = tslib_1.__importDefault(require("date-fns/addWeeks"));
var addMinutes_1 = tslib_1.__importDefault(require("date-fns/addMinutes"));
var addHours_1 = tslib_1.__importDefault(require("date-fns/addHours"));
var subSeconds_1 = tslib_1.__importDefault(require("date-fns/subSeconds"));
var subMinutes_1 = tslib_1.__importDefault(require("date-fns/subMinutes"));
var subHours_1 = tslib_1.__importDefault(require("date-fns/subHours"));
var subDays_1 = tslib_1.__importDefault(require("date-fns/subDays"));
var subWeeks_1 = tslib_1.__importDefault(require("date-fns/subWeeks"));
var subMonths_1 = tslib_1.__importDefault(require("date-fns/subMonths"));
var subQuarters_1 = tslib_1.__importDefault(require("date-fns/subQuarters"));
var subYears_1 = tslib_1.__importDefault(require("date-fns/subYears"));
var addDays_1 = tslib_1.__importDefault(require("date-fns/addDays"));
var addQuarters_1 = tslib_1.__importDefault(require("date-fns/addQuarters"));
var addYears_1 = tslib_1.__importDefault(require("date-fns/addYears"));
var addSeconds_1 = tslib_1.__importDefault(require("date-fns/addSeconds"));
var differenceInMinutes_1 = tslib_1.__importDefault(require("date-fns/differenceInMinutes"));
var differenceInHours_1 = tslib_1.__importDefault(require("date-fns/differenceInHours"));
var differenceInWeeks_1 = tslib_1.__importDefault(require("date-fns/differenceInWeeks"));
var differenceInQuarters_1 = tslib_1.__importDefault(require("date-fns/differenceInQuarters"));
var differenceInYears_1 = tslib_1.__importDefault(require("date-fns/differenceInYears"));
var startOfSecond_1 = tslib_1.__importDefault(require("date-fns/startOfSecond"));
var startOfWeek_1 = tslib_1.__importDefault(require("date-fns/startOfWeek"));
var startOfMonth_1 = tslib_1.__importDefault(require("date-fns/startOfMonth"));
var startOfYear_1 = tslib_1.__importDefault(require("date-fns/startOfYear"));
var startOfHour_1 = tslib_1.__importDefault(require("date-fns/startOfHour"));
var startOfMinute_1 = tslib_1.__importDefault(require("date-fns/startOfMinute"));
var differenceInSeconds_1 = tslib_1.__importDefault(require("date-fns/differenceInSeconds"));
var differenceInDays_1 = tslib_1.__importDefault(require("date-fns/differenceInDays"));
var differenceInMonths_1 = tslib_1.__importDefault(require("date-fns/differenceInMonths"));
var startOfDay_1 = tslib_1.__importDefault(require("date-fns/startOfDay"));
var startOfQuarter_1 = tslib_1.__importDefault(require("date-fns/startOfQuarter"));
var endOfSecond_1 = tslib_1.__importDefault(require("date-fns/endOfSecond"));
var endOfMinute_1 = tslib_1.__importDefault(require("date-fns/endOfMinute"));
var endOfHour_1 = tslib_1.__importDefault(require("date-fns/endOfHour"));
var endOfDay_1 = tslib_1.__importDefault(require("date-fns/endOfDay"));
var endOfWeek_1 = tslib_1.__importDefault(require("date-fns/endOfWeek"));
var endOfMonth_1 = tslib_1.__importDefault(require("date-fns/endOfMonth"));
var endOfQuarter_1 = tslib_1.__importDefault(require("date-fns/endOfQuarter"));
var endOfYear_1 = tslib_1.__importDefault(require("date-fns/endOfYear"));
var getDay_1 = tslib_1.__importDefault(require("date-fns/getDay"));
var getWeek_1 = tslib_1.__importDefault(require("date-fns/getWeek"));
var isSameMonth_1 = tslib_1.__importDefault(require("date-fns/isSameMonth"));
var isSameQuarter_1 = tslib_1.__importDefault(require("date-fns/isSameQuarter"));
var isSameYear_1 = tslib_1.__importDefault(require("date-fns/isSameYear"));
var isSameDay_1 = tslib_1.__importDefault(require("date-fns/isSameDay"));
var isSameWeek_1 = tslib_1.__importDefault(require("date-fns/isSameWeek"));
var isWithinInterval_1 = tslib_1.__importDefault(require("date-fns/isWithinInterval"));
var isAfter_1 = tslib_1.__importDefault(require("date-fns/isAfter"));
var isValid_1 = tslib_1.__importDefault(require("date-fns/isValid"));
var getDaysInMonth_1 = tslib_1.__importDefault(require("date-fns/getDaysInMonth"));
var setDay_1 = tslib_1.__importDefault(require("date-fns/setDay"));
var setSeconds_1 = tslib_1.__importDefault(require("date-fns/setSeconds"));
var setMinutes_1 = tslib_1.__importDefault(require("date-fns/setMinutes"));
var setHours_1 = tslib_1.__importDefault(require("date-fns/setHours"));
var eachDayOfInterval_1 = tslib_1.__importDefault(require("date-fns/eachDayOfInterval"));
var subMilliseconds_1 = tslib_1.__importDefault(require("date-fns/subMilliseconds"));
var addMilliseconds_1 = tslib_1.__importDefault(require("date-fns/addMilliseconds"));
var getYear_1 = tslib_1.__importDefault(require("date-fns/getYear"));
var format_1 = tslib_1.__importDefault(require("date-fns/format"));
var parse_1 = tslib_1.__importDefault(require("date-fns/parse"));
var differenceInMilliseconds_1 = tslib_1.__importDefault(require("date-fns/differenceInMilliseconds"));
var parseJSON_1 = tslib_1.__importDefault(require("date-fns/parseJSON"));
var getISOWeekYear_1 = tslib_1.__importDefault(require("date-fns/getISOWeekYear"));
var getISOWeek_1 = tslib_1.__importDefault(require("date-fns/getISOWeek"));
var getISODay_1 = tslib_1.__importDefault(require("date-fns/getISODay"));
var mappers_1 = require("../../mappers");
var TcDate = /** @class */ (function () {
    function TcDate(date, format) {
        var _this = this;
        this.getWeekDates = function (weekStartDay) {
            var startOfWeekDate = (0, startOfWeek_1.default)(_this.date, {
                weekStartsOn: weekStartDay,
            });
            var weekDates = [];
            for (var i = 0; i < 7; i++) {
                weekDates.push((0, addDays_1.default)(startOfWeekDate, i));
            }
            return weekDates;
        };
        this.getDayShortName = function (locale) {
            var dayShortName = _this.format('EEE d', locale);
            return dayShortName.charAt(0).toUpperCase() + dayShortName.slice(1);
        };
        this.getYearMonthDayKey = function () {
            return _this.format('yyyy-MM-dd');
        };
        this.getDateOfWeek = function (week, year) {
            var day = 1 + (week - 1) * 7;
            return new Date(year, 0, day);
        };
        this.getDateOfIsoWeek = function (week, year) {
            var simple = new Date(Date.UTC(year, 0, 1 + (week - 1) * 7));
            var dow = simple.getDay();
            var isoWeekStart = simple;
            if (dow <= 4) {
                isoWeekStart.setDate(simple.getDate() - simple.getDay() + 1);
            }
            else {
                isoWeekStart.setDate(simple.getDate() + 8 - simple.getDay());
            }
            return isoWeekStart;
        };
        this.getIsoWeekAndYear = function () {
            return {
                year: (0, getISOWeekYear_1.default)(_this.date),
                week: (0, getISOWeek_1.default)(_this.date),
                day: (0, getISODay_1.default)(_this.date),
            };
        };
        this.getISODay = function () {
            return (0, getISODay_1.default)(_this.date);
        };
        this.getISOYear = function () {
            return (0, getISOWeekYear_1.default)(_this.date);
        };
        this.getIsoWeek = function () {
            return (0, getISOWeek_1.default)(_this.date);
        };
        this.getDateWithoutTimeAsUTC = function () {
            if (!_this.date) {
                throw new Error('Date is null');
            }
            return new Date(Date.UTC(_this.date.getFullYear(), _this.date.getMonth(), _this.date.getDate(), 0, 0, 0, 0));
        };
        if (!date) {
            date = new Date();
        }
        if (typeof date === 'string') {
            if (format) {
                this.date = (0, parse_1.default)(date, format, new Date());
            }
            else {
                this.date = (0, parseJSON_1.default)(date);
            }
        }
        else {
            this.date = date;
        }
    }
    TcDate.prototype.toDate = function () {
        return this.date;
    };
    TcDate.prototype.format = function (template, locale) {
        if (locale === void 0) { locale = 'en'; }
        if (template === 'h:mma') {
            template = 'h:mmaaa';
        }
        var mappedTemplate = (0, mappers_1.mapTcDateFormatToDateFnsDateFormat)(template);
        return (0, format_1.default)(this.date, mappedTemplate, {
            locale: (0, get_date_locale_1.getDateLocale)(locale),
        });
    };
    TcDate.prototype.add = function (amount, type) {
        var date;
        switch (type) {
            case 'milliseconds':
            case 'millisecond':
            case 'ms':
                date = (0, addMilliseconds_1.default)(this.date, amount);
                break;
            case 'seconds':
            case 'second':
            case 's':
                date = (0, addSeconds_1.default)(this.date, amount);
                break;
            case 'minutes':
            case 'minute':
            case 'm':
                date = (0, addMinutes_1.default)(this.date, amount);
                break;
            case 'hours':
            case 'hour':
            case 'h':
                date = (0, addHours_1.default)(this.date, amount);
                break;
            case 'days':
            case 'day':
            case 'd':
                date = (0, addDays_1.default)(this.date, amount);
                break;
            case 'weeks':
            case 'week':
            case 'w':
                date = (0, addWeeks_1.default)(this.date, amount);
                break;
            case 'months':
            case 'month':
            case 'M':
                date = (0, addMonths_1.default)(this.date, amount);
                break;
            case 'quarters':
            case 'quarter':
            case 'q':
                date = (0, addQuarters_1.default)(this.date, amount);
                break;
            case 'years':
            case 'year':
            case 'y':
                date = (0, addYears_1.default)(this.date, amount);
                break;
            default:
                throw new Error("".concat(type, " is not supported"));
        }
        return new TcDate(date);
    };
    TcDate.prototype.subtract = function (amount, type) {
        var date;
        switch (type) {
            case 'milliseconds':
            case 'millisecond':
            case 'ms':
                date = (0, subMilliseconds_1.default)(this.date, amount);
                break;
            case 'seconds':
            case 'second':
            case 's':
                date = (0, subSeconds_1.default)(this.date, amount);
                break;
            case 'minutes':
            case 'minute':
            case 'm':
                date = (0, subMinutes_1.default)(this.date, amount);
                break;
            case 'hours':
            case 'hour':
            case 'h':
                date = (0, subHours_1.default)(this.date, amount);
                break;
            case 'days':
            case 'day':
            case 'd':
                date = (0, subDays_1.default)(this.date, amount);
                break;
            case 'weeks':
            case 'week':
            case 'w':
                date = (0, subWeeks_1.default)(this.date, amount);
                break;
            case 'months':
            case 'month':
            case 'M':
                date = (0, subMonths_1.default)(this.date, amount);
                break;
            case 'quarters':
            case 'quarter':
            case 'q':
                date = (0, subQuarters_1.default)(this.date, amount);
                break;
            case 'years':
            case 'year':
            case 'y':
                date = (0, subYears_1.default)(this.date, amount);
                break;
            default:
                throw new Error("".concat(type, " is not supported"));
        }
        return new TcDate(date);
    };
    TcDate.prototype.diff = function (start, type) {
        var difference = (0, differenceInSeconds_1.default)(this.date, start);
        switch (type) {
            case 'milliseconds':
            case 'millisecond':
            case 'ms':
                difference = (0, differenceInMilliseconds_1.default)(this.date, start);
                break;
            case 'seconds':
            case 'second':
            case 's':
                difference = (0, differenceInSeconds_1.default)(this.date, start);
                break;
            case 'minutes':
            case 'minute':
            case 'm':
                difference = (0, differenceInMinutes_1.default)(this.date, start);
                break;
            case 'hours':
            case 'hour':
            case 'h':
                difference = (0, differenceInHours_1.default)(this.date, start);
                break;
            case 'days':
            case 'day':
            case 'd':
                difference = (0, differenceInDays_1.default)(this.date, start);
                break;
            case 'weeks':
            case 'week':
            case 'w':
                difference = (0, differenceInWeeks_1.default)(this.date, start);
                break;
            case 'months':
            case 'month':
            case 'M':
                difference = (0, differenceInMonths_1.default)(this.date, start);
                break;
            case 'quarters':
            case 'quarter':
            case 'q':
                difference = (0, differenceInQuarters_1.default)(this.date, start);
                break;
            case 'years':
            case 'year':
            case 'y':
                difference = (0, differenceInYears_1.default)(this.date, start);
                break;
            default:
                throw new Error("".concat(type, " is not supported"));
        }
        return difference;
    };
    TcDate.prototype.startOf = function (type, weekStartDay) {
        var date;
        switch (type) {
            case 'seconds':
            case 'second':
            case 's':
                date = (0, startOfSecond_1.default)(this.date);
                break;
            case 'minutes':
            case 'minute':
            case 'm':
                date = (0, startOfMinute_1.default)(this.date);
                break;
            case 'hours':
            case 'hour':
            case 'h':
                date = (0, startOfHour_1.default)(this.date);
                break;
            case 'days':
            case 'day':
            case 'd':
                date = (0, startOfDay_1.default)(this.date);
                break;
            case 'weeks':
            case 'week':
            case 'w':
                date = (0, startOfWeek_1.default)(this.date, { weekStartsOn: weekStartDay });
                break;
            case 'months':
            case 'month':
            case 'M':
                date = (0, startOfMonth_1.default)(this.date);
                break;
            case 'quarters':
            case 'quarter':
            case 'q':
                date = (0, startOfQuarter_1.default)(this.date);
                break;
            case 'years':
            case 'year':
            case 'y':
                date = (0, startOfYear_1.default)(this.date);
                break;
            default:
                throw new Error("".concat(type, " is not supported"));
        }
        return new TcDate(date);
    };
    TcDate.prototype.endOf = function (type, weekStartDay) {
        var date;
        switch (type) {
            case 'seconds':
            case 'second':
            case 's':
                date = (0, endOfSecond_1.default)(this.date);
                break;
            case 'minutes':
            case 'minute':
            case 'm':
                date = (0, endOfMinute_1.default)(this.date);
                break;
            case 'hours':
            case 'hour':
            case 'h':
                date = (0, endOfHour_1.default)(this.date);
                break;
            case 'days':
            case 'day':
            case 'd':
                date = (0, endOfDay_1.default)(this.date);
                break;
            case 'weeks':
            case 'week':
            case 'w':
                date = (0, endOfWeek_1.default)(this.date, { weekStartsOn: weekStartDay });
                break;
            case 'months':
            case 'month':
            case 'M':
                date = (0, endOfMonth_1.default)(this.date);
                break;
            case 'quarters':
            case 'quarter':
            case 'q':
                date = (0, endOfQuarter_1.default)(this.date);
                break;
            case 'years':
            case 'year':
            case 'y':
                date = (0, endOfYear_1.default)(this.date);
                break;
            default:
                throw new Error("".concat(type, " is not supported"));
        }
        return new TcDate(date);
    };
    TcDate.prototype.weekday = function () {
        return (0, getDay_1.default)(this.date);
    };
    TcDate.prototype.weekdayToDate = function (day, weekStartDay) {
        return (0, setDay_1.default)(this.date, day, { weekStartsOn: weekStartDay });
    };
    TcDate.prototype.week = function (weekStartDay) {
        return (0, getWeek_1.default)(this.date, { weekStartsOn: weekStartDay });
    };
    TcDate.prototype.year = function () {
        return (0, getYear_1.default)(this.date);
    };
    TcDate.prototype.isSame = function (dateToCheck, type, weekStartDay) {
        switch (type) {
            case 'days':
            case 'day':
            case 'd':
                return (0, isSameDay_1.default)(this.date, dateToCheck);
            case 'weeks':
            case 'week':
            case 'w':
                return (0, isSameWeek_1.default)(this.date, dateToCheck, {
                    weekStartsOn: weekStartDay,
                });
            case 'months':
            case 'month':
            case 'M':
                return (0, isSameMonth_1.default)(this.date, dateToCheck);
            case 'quarters':
            case 'quarter':
            case 'q':
                return (0, isSameQuarter_1.default)(this.date, dateToCheck);
            case 'years':
            case 'year':
            case 'y':
                return (0, isSameYear_1.default)(this.date, dateToCheck);
            default:
                throw new Error("".concat(type, " is not supported"));
        }
    };
    TcDate.prototype.isBetween = function (_a) {
        var start = _a.start, end = _a.end;
        return (0, isWithinInterval_1.default)(this.date, {
            start: start,
            end: end,
        });
    };
    TcDate.prototype.isAfter = function (dateToCheck) {
        return (0, isAfter_1.default)(this.date, dateToCheck);
    };
    TcDate.prototype.isValid = function () {
        return (0, isValid_1.default)(this.date);
    };
    TcDate.prototype.set = function (amount, type) {
        var date;
        switch (type) {
            case 'second':
            case 'seconds':
                date = (0, setSeconds_1.default)(this.date, amount);
                break;
            case 'minute':
            case 'minutes':
                date = (0, setMinutes_1.default)(this.date, amount);
                break;
            case 'hour':
            case 'hours':
                date = (0, setHours_1.default)(this.date, amount);
        }
        return new TcDate(date);
    };
    TcDate.prototype.daysInMonth = function () {
        return (0, getDaysInMonth_1.default)(this.date);
    };
    TcDate.prototype.toISOString = function () {
        return this.date.toISOString();
    };
    TcDate.prototype.interval = function (start, end) {
        return (0, eachDayOfInterval_1.default)({
            start: start,
            end: end,
        });
    };
    return TcDate;
}());
exports.TcDate = TcDate;
//# sourceMappingURL=date.js.map